import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsStockInMerchant, GoodsStockInMerchantParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商户商品库存
 */
export async function pageGoodsStockInMerchant(params: GoodsStockInMerchantParam) {
  const res = await request.get<ApiResult<PageResult<GoodsStockInMerchant>>>(
    MODULES_API_URL + '/shop/goods-stock-in-merchant/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商户商品库存列表
 */
export async function listGoodsStockInMerchant(params?: GoodsStockInMerchantParam) {
  const res = await request.get<ApiResult<GoodsStockInMerchant[]>>(
    MODULES_API_URL + '/shop/goods-stock-in-merchant',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商户商品库存
 */
export async function addGoodsStockInMerchant(data: GoodsStockInMerchant) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-stock-in-merchant',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商户商品库存
 */
export async function updateGoodsStockInMerchant(data: GoodsStockInMerchant) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-stock-in-merchant',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商户商品库存
 */
export async function removeGoodsStockInMerchant(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-stock-in-merchant/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商户商品库存
 */
export async function removeBatchGoodsStockInMerchant(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-stock-in-merchant/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商户商品库存
 */
export async function getGoodsStockInMerchant(id: number) {
  const res = await request.get<ApiResult<GoodsStockInMerchant>>(
    MODULES_API_URL + '/shop/goods-stock-in-merchant/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
